org.objectweb.asm

## Class ClassWriter

- java.lang.Object
- - org.objectweb.asm.ClassVisitor
  - - org.objectweb.asm.ClassWriter

-     public class ClassWriter
      extends ClassVisitor

  A `ClassVisitor` that generates classes in bytecode form. More precisely this visitor generates a byte array conforming to the Java class file format. It can be used alone, to generate a Java class "from scratch", or with one or more `ClassReader` and adapter class visitor to generate a modified class from one or more existing Java classes.
  Author:
    Eric Bruneton

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `COMPUTE_FRAMES` Flag to automatically compute the stack map frames of methods from scratch.
    `static int` | `COMPUTE_MAXS` Flag to automatically compute the maximum stack size and the maximum number of local variables of methods.

    - ### Fields inherited from class org.objectweb.asm.ClassVisitor

      `api, cv`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ClassWriter(ClassReader classReader, int flags)` Constructs a new `ClassWriter` object and enables optimizations for "mostly add" bytecode transformations.
    `ClassWriter(int flags)` Constructs a new `ClassWriter` object.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected String` | `getCommonSuperClass(String type1, String type2)` Returns the common super type of the two given types.
    `int` | `newClass(String value)` Adds a class reference to the constant pool of the class being build.
    `int` | `newConst(Object cst)` Adds a number or string constant to the constant pool of the class being build.
    `int` | `newField(String owner, String name, String desc)` Adds a field reference to the constant pool of the class being build.
    `int` | `newHandle(int tag, String owner, String name, String desc)` Adds a handle to the constant pool of the class being build.
    `int` | `newInvokeDynamic(String name, String desc, Handle bsm, Object... bsmArgs)` Adds an invokedynamic reference to the constant pool of the class being build.
    `int` | `newMethod(String owner, String name, String desc, boolean itf)` Adds a method reference to the constant pool of the class being build.
    `int` | `newMethodType(String methodDesc)` Adds a method type reference to the constant pool of the class being build.
    `int` | `newNameType(String name, String desc)` Adds a name and type to the constant pool of the class being build.
    `int` | `newUTF8(String value)` Adds an UTF8 string to the constant pool of the class being build.
    `byte[]` | `toByteArray()` Returns the bytecode of the class that was build with this class writer.
    `void` | `visit(int version, int access, String name, String signature, String superName, String[] interfaces)` Visits the header of the class.
    `AnnotationVisitor` | `visitAnnotation(String desc, boolean visible)` Visits an annotation of the class.
    `void` | `visitAttribute(Attribute attr)` Visits a non standard attribute of the class.
    `void` | `visitEnd()` Visits the end of the class.
    `FieldVisitor` | `visitField(int access, String name, String desc, String signature, Object value)` Visits a field of the class.
    `void` | `visitInnerClass(String name, String outerName, String innerName, int access)` Visits information about an inner class.
    `MethodVisitor` | `visitMethod(int access, String name, String desc, String signature, String[] exceptions)` Visits a method of the class.
    `void` | `visitOuterClass(String owner, String name, String desc)` Visits the enclosing class of the class.
    `void` | `visitSource(String file, String debug)` Visits the source of the class.
    `AnnotationVisitor` | `visitTypeAnnotation(int typeRef, TypePath typePath, String desc, boolean visible)` Visits an annotation on a type in the class signature.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### COMPUTE_MAXS

          public static final int COMPUTE_MAXS

      Flag to automatically compute the maximum stack size and the maximum number of local variables of methods. If this flag is set, then the arguments of the `visitMaxs` method of the `MethodVisitor` returned by the `visitMethod` method will be ignored, and computed automatically from the signature and the bytecode of each method.
      See Also:
        `ClassWriter(int)`, Constant Field Values

    - #### COMPUTE_FRAMES

          public static final int COMPUTE_FRAMES

      Flag to automatically compute the stack map frames of methods from scratch. If this flag is set, then the calls to the `MethodVisitor.visitFrame(int, int, java.lang.Object[], int, java.lang.Object[])` method are ignored, and the stack map frames are recomputed from the methods bytecode. The arguments of the `visitMaxs` method are also ignored and recomputed from the bytecode. In other words, computeFrames implies computeMaxs.
      See Also:
        `ClassWriter(int)`, Constant Field Values

  - ### Constructor Detail

    - #### ClassWriter

          public ClassWriter(int flags)

      Constructs a new `ClassWriter` object.
      Parameters:
        `flags` - option flags that can be used to modify the default behavior of this class. See `COMPUTE_MAXS`, `COMPUTE_FRAMES`.

    - #### ClassWriter

          public ClassWriter(ClassReader classReader,
                             int flags)

      Constructs a new `ClassWriter` object and enables optimizations for "mostly add" bytecode transformations. These optimizations are the following:
      - The constant pool from the original class is copied as is in the new class, which saves time. New constant pool entries will be added at the end if necessary, but unused constant pool entries won't be removed.
      - Methods that are not transformed are copied as is in the new class, directly from the original class bytecode (i.e. without emitting visit events for all the method instructions), which saves a lot of time. Untransformed methods are detected by the fact that the `ClassReader` receives `MethodVisitor` objects that come from a `ClassWriter` (and not from any other `ClassVisitor` instance).
      Parameters:
        `classReader` - the `ClassReader` used to read the original class. It will be used to copy the entire constant pool from the original class and also to copy other fragments of original bytecode where applicable.
        `flags` - option flags that can be used to modify the default behavior of this class. These option flags do not affect methods that are copied as is in the new class. This means that the maximum stack size nor the stack frames will be computed for these methods. See `COMPUTE_MAXS`, `COMPUTE_FRAMES`.

  - ### Method Detail

    - #### visit

          public final void visit(int version,
                                  int access,
                                  String name,
                                  String signature,
                                  String superName,
                                  String[] interfaces)

      Description copied from class: `ClassVisitor`
      Visits the header of the class.
      Overrides:
        `visit` in class `ClassVisitor`
      Parameters:
        `version` - the class version.
        `access` - the class's access flags (see `Opcodes`). This parameter also indicates if the class is deprecated.
        `name` - the internal name of the class (see `getInternalName`).
        `signature` - the signature of this class. May be `null` if the class is not a generic one, and does not extend or implement generic classes or interfaces.
        `superName` - the internal of name of the super class (see `getInternalName`). For interfaces, the super class is `Object`. May be `null`, but only for the `Object` class.
        `interfaces` - the internal names of the class's interfaces (see `getInternalName`). May be `null`.

    - #### visitSource

          public final void visitSource(String file,
                                        String debug)

      Description copied from class: `ClassVisitor`
      Visits the source of the class.
      Overrides:
        `visitSource` in class `ClassVisitor`
      Parameters:
        `file` - the name of the source file from which the class was compiled. May be `null`.
        `debug` - additional debug information to compute the correspondance between source and compiled elements of the class. May be `null`.

    - #### visitOuterClass

          public final void visitOuterClass(String owner,
                                            String name,
                                            String desc)

      Description copied from class: `ClassVisitor`
      Visits the enclosing class of the class. This method must be called only if the class has an enclosing class.
      Overrides:
        `visitOuterClass` in class `ClassVisitor`
      Parameters:
        `owner` - internal name of the enclosing class of the class.
        `name` - the name of the method that contains the class, or `null` if the class is not enclosed in a method of its enclosing class.
        `desc` - the descriptor of the method that contains the class, or `null` if the class is not enclosed in a method of its enclosing class.

    - #### visitAnnotation

          public final AnnotationVisitor visitAnnotation(String desc,
                                                         boolean visible)

      Description copied from class: `ClassVisitor`
      Visits an annotation of the class.
      Overrides:
        `visitAnnotation` in class `ClassVisitor`
      Parameters:
        `desc` - the class descriptor of the annotation class.
        `visible` - `true` if the annotation is visible at runtime.
      Returns:
        a visitor to visit the annotation values, or `null` if this visitor is not interested in visiting this annotation.

    - #### visitTypeAnnotation

          public final AnnotationVisitor visitTypeAnnotation(int typeRef,
                                                             TypePath typePath,
                                                             String desc,
                                                             boolean visible)

      Description copied from class: `ClassVisitor`
      Visits an annotation on a type in the class signature.
      Overrides:
        `visitTypeAnnotation` in class `ClassVisitor`
      Parameters:
        `typeRef` - a reference to the annotated type. The sort of this type reference must be `CLASS_TYPE_PARAMETER`, `CLASS_TYPE_PARAMETER_BOUND` or `CLASS_EXTENDS`. See `TypeReference`.
        `typePath` - the path to the annotated type argument, wildcard bound, array element type, or static inner type within 'typeRef'. May be `null` if the annotation targets 'typeRef' as a whole.
        `desc` - the class descriptor of the annotation class.
        `visible` - `true` if the annotation is visible at runtime.
      Returns:
        a visitor to visit the annotation values, or `null` if this visitor is not interested in visiting this annotation.

    - #### visitAttribute

          public final void visitAttribute(Attribute attr)

      Description copied from class: `ClassVisitor`
      Visits a non standard attribute of the class.
      Overrides:
        `visitAttribute` in class `ClassVisitor`
      Parameters:
        `attr` - an attribute.

    - #### visitInnerClass

          public final void visitInnerClass(String name,
                                            String outerName,
                                            String innerName,
                                            int access)

      Description copied from class: `ClassVisitor`
      Visits information about an inner class. This inner class is not necessarily a member of the class being visited.
      Overrides:
        `visitInnerClass` in class `ClassVisitor`
      Parameters:
        `name` - the internal name of an inner class (see `getInternalName`).
        `outerName` - the internal name of the class to which the inner class belongs (see `getInternalName`). May be `null` for not member classes.
        `innerName` - the (simple) name of the inner class inside its enclosing class. May be `null` for anonymous inner classes.
        `access` - the access flags of the inner class as originally declared in the enclosing class.

    - #### visitField

          public final FieldVisitor visitField(int access,
                                               String name,
                                               String desc,
                                               String signature,
                                               Object value)

      Description copied from class: `ClassVisitor`
      Visits a field of the class.
      Overrides:
        `visitField` in class `ClassVisitor`
      Parameters:
        `access` - the field's access flags (see `Opcodes`). This parameter also indicates if the field is synthetic and/or deprecated.
        `name` - the field's name.
        `desc` - the field's descriptor (see `Type`).
        `signature` - the field's signature. May be `null` if the field's type does not use generic types.
        `value` - the field's initial value. This parameter, which may be `null` if the field does not have an initial value, must be an `Integer`, a `Float`, a `Long`, a `Double` or a `String` (for `int`, `float`, `long` or `String` fields respectively). This parameter is only used for static fields. Its value is ignored for non static fields, which must be initialized through bytecode instructions in constructors or methods.
      Returns:
        a visitor to visit field annotations and attributes, or `null` if this class visitor is not interested in visiting these annotations and attributes.

    - #### visitMethod

          public final MethodVisitor visitMethod(int access,
                                                 String name,
                                                 String desc,
                                                 String signature,
                                                 String[] exceptions)

      Description copied from class: `ClassVisitor`
      Visits a method of the class. This method must return a new `MethodVisitor` instance (or `null`) each time it is called, i.e., it should not return a previously returned visitor.
      Overrides:
        `visitMethod` in class `ClassVisitor`
      Parameters:
        `access` - the method's access flags (see `Opcodes`). This parameter also indicates if the method is synthetic and/or deprecated.
        `name` - the method's name.
        `desc` - the method's descriptor (see `Type`).
        `signature` - the method's signature. May be `null` if the method parameters, return type and exceptions do not use generic types.
        `exceptions` - the internal names of the method's exception classes (see `getInternalName`). May be `null`.
      Returns:
        an object to visit the byte code of the method, or `null` if this class visitor is not interested in visiting the code of this method.

    - #### visitEnd

          public final void visitEnd()

      Description copied from class: `ClassVisitor`
      Visits the end of the class. This method, which is the last one to be called, is used to inform the visitor that all the fields and methods of the class have been visited.
      Overrides:
        `visitEnd` in class `ClassVisitor`

    - #### toByteArray

          public byte[] toByteArray()

      Returns the bytecode of the class that was build with this class writer.
      Returns:
        the bytecode of the class that was build with this class writer.

    - #### newConst

          public int newConst(Object cst)

      Adds a number or string constant to the constant pool of the class being build. Does nothing if the constant pool already contains a similar item. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.
      Parameters:
        `cst` - the value of the constant to be added to the constant pool. This parameter must be an `Integer`, a `Float`, a `Long`, a `Double` or a `String`.
      Returns:
        the index of a new or already existing constant item with the given value.

    - #### newUTF8

          public int newUTF8(String value)

      Adds an UTF8 string to the constant pool of the class being build. Does nothing if the constant pool already contains a similar item. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.
      Parameters:
        `value` - the String value.
      Returns:
        the index of a new or already existing UTF8 item.

    - #### newClass

          public int newClass(String value)

      Adds a class reference to the constant pool of the class being build. Does nothing if the constant pool already contains a similar item. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.
      Parameters:
        `value` - the internal name of the class.
      Returns:
        the index of a new or already existing class reference item.

    - #### newMethodType

          public int newMethodType(String methodDesc)

      Adds a method type reference to the constant pool of the class being build. Does nothing if the constant pool already contains a similar item. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.
      Parameters:
        `methodDesc` - method descriptor of the method type.
      Returns:
        the index of a new or already existing method type reference item.

    - #### newHandle

          public int newHandle(int tag,
                               String owner,
                               String name,
                               String desc)

      Adds a handle to the constant pool of the class being build. Does nothing if the constant pool already contains a similar item. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.
      Parameters:
        `tag` - the kind of this handle. Must be `Opcodes.H_GETFIELD`, `Opcodes.H_GETSTATIC`, `Opcodes.H_PUTFIELD`, `Opcodes.H_PUTSTATIC`, `Opcodes.H_INVOKEVIRTUAL`, `Opcodes.H_INVOKESTATIC`, `Opcodes.H_INVOKESPECIAL`, `Opcodes.H_NEWINVOKESPECIAL` or `Opcodes.H_INVOKEINTERFACE`.
        `owner` - the internal name of the field or method owner class.
        `name` - the name of the field or method.
        `desc` - the descriptor of the field or method.
      Returns:
        the index of a new or already existing method type reference item.

    - #### newInvokeDynamic

          public int newInvokeDynamic(String name,
                                      String desc,
                                      Handle bsm,
                                      Object... bsmArgs)

      Adds an invokedynamic reference to the constant pool of the class being build. Does nothing if the constant pool already contains a similar item. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.
      Parameters:
        `name` - name of the invoked method.
        `desc` - descriptor of the invoke method.
        `bsm` - the bootstrap method.
        `bsmArgs` - the bootstrap method constant arguments.
      Returns:
        the index of a new or already existing invokedynamic reference item.

    - #### newField

          public int newField(String owner,
                              String name,
                              String desc)

      Adds a field reference to the constant pool of the class being build. Does nothing if the constant pool already contains a similar item. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.
      Parameters:
        `owner` - the internal name of the field's owner class.
        `name` - the field's name.
        `desc` - the field's descriptor.
      Returns:
        the index of a new or already existing field reference item.

    - #### newMethod

          public int newMethod(String owner,
                               String name,
                               String desc,
                               boolean itf)

      Adds a method reference to the constant pool of the class being build. Does nothing if the constant pool already contains a similar item. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.
      Parameters:
        `owner` - the internal name of the method's owner class.
        `name` - the method's name.
        `desc` - the method's descriptor.
        `itf` - `true` if `owner` is an interface.
      Returns:
        the index of a new or already existing method reference item.

    - #### newNameType

          public int newNameType(String name,
                                 String desc)

      Adds a name and type to the constant pool of the class being build. Does nothing if the constant pool already contains a similar item. This method is intended for `Attribute` sub classes, and is normally not needed by class generators or adapters.
      Parameters:
        `name` - a name.
        `desc` - a type descriptor.
      Returns:
        the index of a new or already existing name and type item.

    - #### getCommonSuperClass

          protected String getCommonSuperClass(String type1,
                                               String type2)

      Returns the common super type of the two given types. The default implementation of this method loads the two given classes and uses the java.lang.Class methods to find the common super class. It can be overridden to compute this common super type in other ways, in particular without actually loading any class, or to take into account the class that is currently being generated by this ClassWriter, which can of course not be loaded since it is under construction.
      Parameters:
        `type1` - the internal name of a class.
        `type2` - the internal name of another class.
      Returns:
        the internal name of the common super class of the two given classes.